<?php
class Birthday_reminder extends plxPlugin {
	public function __construct($default_lang) {
		# appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);

		# limite l'accès à l'écran d'administration du plugin
		# PROFIL_ADMIN , PROFIL_MANAGER , PROFIL_MODERATOR , PROFIL_EDITOR , PROFIL_WRITER
		$this->setConfigProfil(PROFIL_ADMIN);
		
		# Déclaration d'un hook (existant ou nouveau)
		$this->addHook('BirthdayReminder_here','BirthdayReminder_here');
		$this->addHook('plxAdminEditProfil','plxAdminEditProfil');
		$this->addHook('plxAdminEditUsersUpdate','plxAdminEditUsersUpdate');
		$this->addHook('plxAdminEditUser','plxAdminEditUser');
		$this->addHook('plxMotorGetUsers','plxMotorGetUsers');
		$this->addHook('AdminProfil','AdminProfil');
		$this->addHook('AdminUser','AdminUser');
		$this->addHook('plxAdminEditUsersXml','plxAdminEditUsersXml');

		
	}

	# Activation / désactivation
	public function OnActivate() {
		# code à exécuter à l’activation du plugin
	}
	public function OnDeactivate() {
		# code à exécuter à la désactivation du plugin
	}
	

	private function getavatar($nom){
		if (!empty($nom)){
			global $plxMotor;			
			$tmp= '<p class="avatar">';
			$avatar=glob(PLX_ROOT.'data/avatars/'.$nom.'.*');
			if (empty($avatar)){$avatar=PLX_PLUGINS.'AdProfileAvatar/default.png';}
			else{$avatar=$avatar[0];}
			$tmp.= '<img src="'.$avatar.'"/>';
			$tmp.= '</p>';
			return $tmp;
		}
	}
	private function echo_birthday($array,$msg=null){
		if (!empty($array)){

			echo '<div class="birthday_reminder">';
				if (count($array)>2){
						foreach ($array as $i){
							$age=intval(date('Y')-intval($array[0]['year']));
							if (empty($msg)){$msg=$i['date'];}
							echo $this->getavatar($i['name']).'<div>'.$msg.'<br/>'.$i['name'].' ('.$age.' ans)</div>';
						}
					}else{
						$age=intval(date('Y')-intval($array[0]['year']));
						if (empty($msg)){$msg=$array[0]['date'];}
						echo $this->getavatar($array[0]['name']).'<div>'.$msg.'<br/>'.$array[0]['name'].' ('.$age.' ans)</div>';
					}
			echo '</div>';
		}
	}

	# HOOKS
	# ajoute un rappel du prochain anniversaire / anniversaire du jour
	public function BirthdayReminder_here(){
		global $plxMotor;
		$j=date('j');
		$m=date('n');
		$a=date('Y');
		$aUsers=$plxMotor->aUsers;
		foreach($aUsers as $u){
			if (!empty($u['birthday'])){	
				$b=explode('/',$u['birthday']);
				$dats[intval($b[0])][intval($b[1])][]=array('name'=>$u['name'],'year'=>$b[2],'date'=>$u['birthday']);
			}
		}

		
			# un anniv aujourd'hui ?
			if (!empty($dats[$j][$m])){				
				$this->echo_birthday($dats[$j][$m],'Aujourd\'hui !');return;
			}else{

				# gestion duprochain anniv sur la liste
					#d'ici à la fin du mois
					for ($jour=$j+1;$jour<32;$jour++){
						if (!empty($dats[$jour][$m])){	$this->echo_birthday($dats[$jour][$m]);return;}
					}

					#Du mois suivant à la fin de l'année
					for ($mois=$m+1;$mois<13;$mois++){
						for ($jour=1;$jour<32;$jour++){							
							if ($dats[$jour][$mois]!=''){$this->echo_birthday($dats[$jour][$mois]);return;}
						}
					}


					# aucun anniv' d'ici la fin de l'année ? Quid du début ?				
					for ($mois=1;$mois<$m;$mois++){
						for ($jour=1;$jour<31;$jour++){
							if (!empty($dats[$jour][$mois])){
								$this->echo_birthday($dats[$jour][$mois]);
								return;
							}
						}
						
					}			
			}
		}




			

	

	# Ajout de la variable birthday dans les fonctions de gestion des profils
	public function plxAdminEditProfil(){
		echo '<?php $this->aUsers[$_SESSION["user"]]["birthday"] = $content["birthday"];?>';
	}
	public function plxAdminEditUsersUpdate(){
		echo '<?php $this->aUsers[$user_id]["birthday"] = (isset($this->aUsers[$user_id]["birthday"])?$this->aUsers[$user_id]["birthday"]:"");?>';
	}
	public function plxAdminEditUser(){
		echo '<?php $this->aUsers[$content["id"]]["birthday"] = $content["birthday"];?>';
	}
	public function plxMotorGetUsers(){
		echo '
			<?php 
				$birthday = plxUtils::getValue($iTags["birthday"][$i]);
				if (empty($birthday)){$birthday="";}
				$this->aUsers[$number]["birthday"]=plxUtils::getValue($values[$birthday]["value"]);
			?>		
		';
	}
	public function AdminProfil(){
		echo '
		 <fieldset><p class="field"><label for="id_birthday">Date de naissance (jj/mm/aaa)&nbsp;:</label></p>
		 <?php plxUtils::printInput("birthday", plxUtils::strCheck($_profil["birthday"]), "text", "10") ?></fieldset>
		 ';
	}
	public function AdminUser(){
		echo '
		 <fieldset><p class="field"><label for="id_birthday">Date de naissance (jj/mm/aaa)&nbsp;:</label></p>
		 <?php plxUtils::printInput("birthday", plxUtils::strCheck($plxAdmin->aUsers[$id]["birthday"]), "text", "10") ?></fieldset>
		 ';
	}
	public function plxAdminEditUsersXml(){
		echo '<?php $xml .= "\t\t<birthday><![CDATA[".plxUtils::cdataCheck($user["birthday"])."]]></birthday>\n";?>';
	}

	

}





/* Pense-bête:
 * Récuperer des parametres du fichier parameters.xml
 *	$this->getParam("<nom du parametre>")
 *	$this-> setParam ("param1", 12345, "numeric")
 *	$this->saveParams()
 *
 *	plxUtils::strCheck($string) : sanitize string
 *
 * 
 * Quelques constantes utiles: 
 * PLX_CORE
 * PLX_ROOT
 * PLX_CHARSET
 * PLX_CONFIG_PATH
 * PLX_PLUGINS
 *
 * Appel de HOOK
 *	eval($plxShow->callHook("ThemeEndHead","param1"))  ou eval($plxShow->callHook("ThemeEndHead",array("param1","param2")))
 *	ou $retour=$plxShow->callHook("ThemeEndHead","param1"));
 */
?>
